//+------------------------------------------------------------------------------------------------+
//| LIB_OBJECTS.mqh
//+------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Clear Objects @http://kolier.li                                  |
//+------------------------------------------------------------------+
void objClear(string _prefix)
  {
   string _name;
   int obj_total=ObjectsTotal();

   for(int i=obj_total-1; i>=0; i--)
     {
      _name=ObjectName(i);
      if(StringFind(_name,_prefix)==0) ObjectDelete(_name);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void objLabel(string _name,int _corner,int _xpos,int _ypos,string _font,int _fsize,color _fcolor,string _text)
  {
   if(ObjectFind(_name)<0)
     {
      ObjectCreate(_name,OBJ_LABEL,0,0,0);
      ObjectSet(_name,OBJPROP_CORNER,_corner);
      ObjectSet(_name,OBJPROP_XDISTANCE,_xpos);
      ObjectSet(_name,OBJPROP_YDISTANCE,_ypos);
     }

   ObjectSetText(_name,_text,_fsize,_font,_fcolor);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void objButton(string _name,int _corner,int _xpos,int _ypos,int _width,int _hight,color _fcolor,color _bcolor,int _fsize,string _text)
  {
   if(ObjectFind(_name)<0)
     {
      ObjectCreate(0,_name,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,_name,OBJPROP_CORNER,_corner);
      ObjectSetInteger(0,_name,OBJPROP_XDISTANCE,_xpos);
      ObjectSetInteger(0,_name,OBJPROP_YDISTANCE,_ypos);
      ObjectSetInteger(0,_name,OBJPROP_XSIZE,_width);
      ObjectSetInteger(0,_name,OBJPROP_YSIZE,_hight);
      ObjectSetInteger(0,_name,OBJPROP_COLOR,_fcolor);
      ObjectSetInteger(0,_name,OBJPROP_BGCOLOR,_bcolor);
      ObjectSetInteger(0,_name,OBJPROP_BORDER_COLOR,_bcolor);
      ObjectSetInteger(0,_name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,_name,OBJPROP_BACK,false);
      ObjectSetInteger(0,_name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,_name,OBJPROP_STATE,false);
      ObjectSetInteger(0,_name,OBJPROP_FONTSIZE,_fsize);
     }

   ObjectSetString(0,_name,OBJPROP_TEXT,_text);
  }
//+------------------------------------------------------------------+
//| Set object arrow, create if not exist yet @http://kolier.li      |
//+------------------------------------------------------------------+
void objArrow(string name,int code,datetime time,double price,int window=0,color col=White,int width=1)
  {
   if(ObjectFind(name)==-1) ObjectCreate(name,OBJ_ARROW,window,time,price);

   ObjectSet(name,OBJPROP_ARROWCODE,code);
   ObjectSet(name,OBJPROP_TIME1,time);
   ObjectSet(name,OBJPROP_PRICE1,price);
   ObjectSet(name,OBJPROP_COLOR,col);
   ObjectSet(name,OBJPROP_WIDTH,width);
  }
//+------------------------------------------------------------------+
//| Set Object Text, create if not exist yet @http://kolier.li       |
//+------------------------------------------------------------------+
void objText(string name,string tex,datetime time,double price,int window=0,color tex_color=White,string tex_font="Arial",int tex_size=12)
  {
   if(ObjectFind(name)==-1) ObjectCreate(name,OBJ_TEXT,window,time,price);

   ObjectSet(name,OBJPROP_TIME1,time);
   ObjectSet(name,OBJPROP_PRICE1,price);
   ObjectSetText(name,tex,tex_size,tex_font,tex_color);
  }
//+------------------------------------------------------------------+
//| Set Object Rectangle, create if not exist yet @http://kolier.li  |
//+------------------------------------------------------------------+
void objRectangle(string name,datetime time_1,double price_1,datetime time_2,double price_2,int window=0,color color_obj=Blue,bool draw_back=true)
  {
   if(ObjectFind(name)==-1) ObjectCreate(name,OBJ_RECTANGLE,window,time_1,price_1,time_2,price_2);

   ObjectSet(name,OBJPROP_TIME1,time_1);
   ObjectSet(name,OBJPROP_PRICE1,price_1);
   ObjectSet(name,OBJPROP_TIME2,time_2);
   ObjectSet(name,OBJPROP_PRICE2,price_2);
   ObjectSet(name,OBJPROP_COLOR,color_obj);
   ObjectSet(name,OBJPROP_BACK,draw_back);
  }
//+------------------------------------------------------------------------------------------------+
